#!/usr/bin/perl

$ignore_events = "(absolute-dynamic|breathing|crescendo|decrescendo|key-change|rest|trill-span)";

$skip = 0;
while (<>) {
    # print "skip = $skip; now consider $_\n";
	if ($skip > 0) {
		$skip -= 1;
    } elsif ( /programming error: Grob direction requested while calculation in progress./ ) {
      $skip = 1;
	} elsif ( /warning: (cannot have note heads and rests together on a stem|rhythmic head is not part of a rhythmic column)/ ) {
		$skip = 2;
	} elsif ( /programming error: No spacing entry from Item to `custos'/ ) {
		$skip = 2;
    } elsif ( /ly:([0-9]+):.* warning: adding note head to incompatible stem \(type = 1\/[14]\)/ ) {
        $skip = 2;
        $skip_line = $1;
    } elsif ( /ly:([0-9]+):.* warning: maybe input should specify polyphonic voices/ ) {
        if ($1 == $skip_line) {
            $skip = 2;
            $skip_line = -1;
        } else {
            print $_;
        }
    } elsif ( /.*berg-7-fruhe-[457].ily:.*: warning: Bar number is 2; expect/ ) {
        $skip = 2;
    } elsif ( /ly:([0-9]+):.* warning: conflict with event: `$ignore_events-event'/ ) {
        $skip = 2;
    } elsif ( /ly:([0-9]+):.* warning: discarding event: `$ignore_events-event'/ ) {
        $skip = 2;
    } elsif ( /^ *cannot have note heads and rests together on a stem$/ ) {
    } elsif ( /^        maybe input should specify polyphonic voices$/ ) {
    } elsif ( /^        no viable initial configuration found: may not find good beam slope$/ ) {
    } else {
        print $_;
    }
}
