\version "2.21.0"

\include "include-once.ily"

\includeOnce "schreker-valse-lente.ily"

\includeOnce "schreker-valse-lente-paged-title.ily"
\includeOnce "last-page-copyright.ily"



\header {
    instrument = "Oboe"
}

\paper {
    % page-count = #    % finalize
    % ragged-last-bottom = ##f
    ragged-right = ##f
}


breaksI = <<
\mvtItimeline
{
    % \time 4/4
    s1*7 |
    \barNumberCheck # 8
    % \time 3/4
    s2.*8 |
    \barNumberCheck # 16
    % [1]
    s2.*11 |
    \barNumberCheck # 27
    % [2]
    s2.*12 |
    \barNumberCheck # 39
    \break
    % \repeat volta 2 {
        % [3]
        s2.*8 |
        \barNumberCheck # 47
        % [4]
        s2.*8 |
        \barNumberCheck # 55
        % [5]
        s2.*8 |
        \barNumberCheck # 63
        % [6]
        s2.*8 |
        \barNumberCheck # 71
        % [7]
        s2.*7 |
    % }
    \barNumberCheck # 78
    % \alternative {
        s2. |
        % [8]
        s2.*10 |
    % } {
        s2. |
    % }
    \barNumberCheck # 90
    % [9]
    s2.*16 |
    \barNumberCheck # 106
    % [10]
    s2.*11 |
    \barNumberCheck # 117
    % [11]
    s2.*12 |
    \barNumberCheck # 129
    % [12]
    s2.*6 |
    \barNumberCheck # 135
    % [13]
    s2.*11 |
    \barNumberCheck # 146
}
>>


cuesI = <<
\mvtItimeline
\relative c'' {
    \transposition c
    % \time 4/4
    s1 |
    <> -\offset X-offset #-1.5 ^\markup\normalsize{I.Violino}
    \cueDuring mvtIvlnI #UP {
        s1*2 |
    }
    s1*4 |
    \barNumberCheck # 8
    % \time 3/4
    <> -\offset X-offset #-1.5 ^\markup\normalsize{Clarinetto}
    \cueDuring mvtIclrI #UP {
        s2.*4 |
    }
    s2.*4 |
    \barNumberCheck # 16
    % [1]
    s2.*3 |
    \barNumberCheck # 19
    \at 16 -\offset X-offset #-1.5 ^\markup\normalsize{Clarinetto}
    \cueDuring mvtIclrI #UP {
        s2.*7 |
    }
    s2.*1 |
    \barNumberCheck # 27
    % [2]
    s2.*12 |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        s2.*8 |
        \barNumberCheck # 47
        % [4]
        s2.*8 |
        \barNumberCheck # 55
        % [5]
        s2.*8 |
        \barNumberCheck # 63
        % [6]
        s2.*8 |
        \barNumberCheck # 71
        % [7]
        s2.*7 |
    % }
    \barNumberCheck # 78
    % \alternative {
        s2. |
        % [8]
        s2.*10 |
    % } {
        s2. |
    % }
    \barNumberCheck # 90
    % [9]
    s2.*16 |
    \barNumberCheck # 106
    % [10]
    s2.*3 |
    \barNumberCheck # 109
    \at 16 -\offset X-offset #-1.5 ^\markup\normalsize{Clarinetto}
    \cueDuring mvtIclrI #UP {
        s2.*7 |
    }
    s2.*1 |
    \barNumberCheck # 117
    % [11]
    s2.*12 |
    \barNumberCheck # 129
    % [12]
    s2.*6 |
    \barNumberCheck # 135
    % [13]
    s2.*11 |
    \barNumberCheck # 146
}
>>


\score {
    \keepWithTag #'( PARTS KEEPQUOTED ) <<
        \new Dynamics \breaksI

	\new MarkLine \with {
	} <<
	    \mvtItempi
	>>

        \new Staff \with {
        } \context Bottom <<
            \mvtIobI
            \cuesI
        >>
    >>

    \header {
        piece = \mvtIpiece
    }
}
