\version "2.22.0"

\include "include-once.ily"
\includeOnce "schreker-valse-lente-common.ily"


mvtIpiece = "Valse Lente"


mvtItimeline = {
    \time 4/4
    s1*7 |
    \barNumberCheck # 8
    \time 3/4
    s2.*31 |
    \barNumberCheck # 39
    \bar ".|:-||"
    \repeat volta 2 {
        s2.*39 |
    }
    \alternative {
        {
            \barNumberCheck # 78
            s2.*11 |
        }
        {
            s2. |
        }
    }
    \barNumberCheck # 90
    s2.*39 |
    \barNumberCheck # 129
    \bar "||"
    s2.*17 |
    \barNumberCheck # 146
    \bar "|."
}


mvtItempi = <<
\mvtItimeline
{
    % \time 4/4
    \tempo \markup{In leichter Bewegung}
    s1*7 |
    \barNumberCheck # 8
    % \time 3/4
    s2.*8 |
    \barNumberCheck # 16
    \mark \default
    % [1]
    s2.*7 |
    \new TimedSpanner \lyricmode {
        "rit."2. --
        "accel."2. --
        "rit."2. --
        "accel."2. --
        \once \override LyricText.X-offset = #2.0 "Tempo"2.*0
    }
    \barNumberCheck # 27
    \mark \default
    % [2]
    s2.*4 |
    \barNumberCheck # 31
    \tempo \markup\column{\line{In festen Walzer-} \line{rhythmus übergehend}}
    \at 16*95 -\offset X-offset #-0.5 ^\Breathe s2.*8 |
    \barNumberCheck # 39
    % \repeat volta 2 {
        \mark \default
        % [3]
        \once \override Score.MetronomeMark.X-offset = #1.5
        \tempo \markup{Valse}
        s2.*8 |
        \barNumberCheck # 47
        \mark \default
        % [4]
        s2.*8 |
        \barNumberCheck # 55
        \mark \default
        % [5]
        s2.*8 |
        \barNumberCheck # 63
        \mark \default
        % [6]
        s2.*8 |
        \barNumberCheck # 71
        \mark \default
        % [7]
        s2.*7 |
    % }
    \barNumberCheck # 78
    % \alternative {
        s2. |
        \mark \default
        % [8]
        \once \override Score.MetronomeMark.X-offset = #2.0
        \tempo \markup{Zierlich}
        s2.*8 |
        s2 <> -\tweak bound-details.left.text \markup{rit.} \=4\startTextSpan s4 |
        s2 s8 <>\=4\stopTextSpan s8 |
    % } {
        s2. |
    % }
    \barNumberCheck # 90
    \mark \default
    % [9]
    s2. |
    \barNumberCheck # 91
    \tempo \markup{dim. poco a poco}
    s2.*15 |
    \barNumberCheck # 106
    \mark \default
    % [10]
    s2.*7 |
    \new TimedSpanner \lyricmode {
        "rit."2. --
        "accel." --
        "rit." --
        "accel."
        \once \override LyricText.X-offset = #3.5 "Tempo"2.*0
    }
    \barNumberCheck # 117
    \mark \default
    % [11]
    s2.*4 |
    \barNumberCheck # 121
    \tempo \markup\column{\line{In festen Walzer-} \line{rhythmus übergehend}}
    \at 16*95 -\offset X-offset #-3.5 ^\Breathe s2.*8 |
    \barNumberCheck # 129
    % \bar "||"
    \mark \default
    % [12]
    \once \override Score.MetronomeMark.X-offset = #3.0
    \tempo \markup{Valse}
    s2.*6 |
    \barNumberCheck # 135
    \mark \default
    % [13]
    s2.*11 |
    \barNumberCheck # 146
    % \bar "|."
}
>>


mvtItemplate = <<
\mvtItimeline
\relative c'' {
    \transposition c
    % \time 4/4
    s1*7 |
    \barNumberCheck # 8
    % \time 3/4
    s2.*8 |
    \barNumberCheck # 16
    % [1]
    s2.*11 |
    \barNumberCheck # 27
    % [2]
    s2.*12 |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        s2.*8 |
        \barNumberCheck # 47
        % [4]
        s2.*8 |
        \barNumberCheck # 55
        % [5]
        s2.*8 |
        \barNumberCheck # 63
        % [6]
        s2.*8 |
        \barNumberCheck # 71
        % [7]
        s2.*7 |
    % }
    \barNumberCheck # 78
    % \alternative {
        s2. |
        % [8]
        s2.*10 |
    % } {
        s2. |
    % }
    \barNumberCheck # 90
    % [9]
    s2.*16 |
    \barNumberCheck # 106
    % [10]
    s2.*11 |
    \barNumberCheck # 117
    % [11]
    s2.*12 |
    \barNumberCheck # 129
    % [12]
    s2.*6 |
    \barNumberCheck # 135
    % [13]
    s2.*11 |
    \barNumberCheck # 146
}
>>


mvtIbreaks = <<
\mvtItimeline
{
    <>^"Breaks left in"
    % \time 4/4
    \repeat unfold 4 { s1\noBreak | } \break
    \repeat unfold 3 { s1\noBreak | } \break
    \barNumberCheck # 8
    % \time 3/4
    \repeat unfold 7 { s2.\noBreak | } \break
    \repeat unfold 6 { s2.\noBreak | } \break
    \repeat unfold 6 { s2.\noBreak | } \break
    \barNumberCheck # 27
    \repeat unfold 6 { s2.\noBreak | } \break
    \repeat unfold 6 { s2.\noBreak | } \break
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        \repeat unfold 6 { s2.\noBreak | } \break
        \repeat unfold 6 { s2.\noBreak | } \break
        \repeat unfold 6 { s2.\noBreak | } \break
        \barNumberCheck # 57
        \repeat unfold 6 { s2.\noBreak | } \break
        \barNumberCheck # 63
        % [6]
        \repeat unfold 4 { s2.\noBreak | } \break
        \repeat unfold 4 { s2.\noBreak | } \break
        \repeat unfold 4 { s2.\noBreak | } \break
        \repeat unfold 4 { s2.\noBreak | } \break
        \repeat unfold 6 { s2.\noBreak | } \break
    \repeat unfold 6 { s2.\noBreak | } \break
    \barNumberCheck # 91
    \repeat unfold 7 { s2.\noBreak | } \break
    \repeat unfold 7 { s2.\noBreak | } \break
    \repeat unfold 6 { s2.\noBreak | } \break
    \barNumberCheck # 111
    \repeat unfold 6 { s2.\noBreak | } \break
    \repeat unfold 6 { s2.\noBreak | } \break
    \repeat unfold 6 { s2.\noBreak | } \break
    \barNumberCheck # 129
    % [12]
    \repeat unfold 6 { s2.\noBreak | } \break
    \repeat unfold 5 { s2.\noBreak | } \break
    \repeat unfold 6 { s2.\noBreak | } \break
    \barNumberCheck # 146
}
>>


mvtIflI = <<
\mvtItimeline
\relative c'' {
    \transposition c
    % \time 4/4
    R1*3 |
    c'2\pp r |
    r16 bes,32\mp[( c] es g bes c) r4 r2 |
    R1*2 |
    \barNumberCheck # 8
    % \time 3/4
    R2.*8 |
    \barNumberCheck # 16
    % [1]
    R2.*11 |
    \barNumberCheck # 27
    % [2]
    R2.*4 |
    c,=''2--\p d4--~ |
    d c2-- |
    e c4~ |
    c d2 |
    es f4~ |
    f es2 |
    as es4\>~ |
    \at 8. \! es g2 |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        R2. |
        r4 r f,\pp( |
        g) r r |
        r r f |
        a2.~ |
        a4 a2 |
        g2.~ |
        g4 r r |
        \barNumberCheck # 47
        % [4]
        R2. |
        r4 r r8 a\mp \Hso -\tweak to-barline ##f -\tweak minimum-length #7.0 \<( |
        b4\Hso\> a8-.\!) r r4 |
        R2.*2 |
        d2.\f |
        R2. |
        r8 g-.\mf a-. b-. c-. d-. |
        \barNumberCheck # 55
        % [5]
        es8.[( f16-.) g8-. f-. es-. d-.] |
        es-. d-. c-. bes-. as-. bes-. |
        \barNumberCheck # 57
        c8.-.[ d16-. es8-. d-. c-. bes-.] |
        c-. bes-. as-. g-. f-. es-. |
        d8.-.[ es16-. f8-. g-. f-. es-.] |
        d-. es-.\< f-. g-. as-. bes-.\! |
        <>\mf( \Rep 3 { b8 cis } |
        b8-.) r r4 r |
        \barNumberCheck # 63
        % [6]
        b2.\mf( |
        cis)~ |
        cis4 b( a) |
        gis( fis e) |
        gis2. |
        b2( a4) |
        gis( fis e~ |
        e) fis( gis) |
        \barNumberCheck # 71
        % [7]
        b2.\f( cis)~ |
        cis4 b( a) |
        gis( fis e) |
        gis2. |
        fis |
        \at 16*5 _\> e~ <>\! |
    % }
    \barNumberCheck # 78
    % \alternative {
        e2 r4 |
        % [8]
        r4 d\p r |
        r c r |
        r a r |
        r g r |
        r d' r |
        r c r |
        r a r |
        r a r |
        r as\> r |
        r as\! r |
    % } {
        e'2\repeatTie r4 |
    % }
    \barNumberCheck # 90
    % [9]
    \at 2. \pp \repeat unfold 2 {
        R2. |
        e4.( e'8) e4 |
        R2. |
        e,4. e'4( e,8) |
    }
    R2.*8 |
    \barNumberCheck # 106
    % [10]
    R2.*11 |
    \barNumberCheck # 117
    % [11]
    R2.*4 |
    c2--\p d4--~ |
    d c2-- |
    e c4~ |
    c d2 |
    es f4~ |
    f es2 |
    as es4\>~ |
    \at 8. \! es g2 |
    \barNumberCheck # 129
    % [12]
    R2. |
    r4 r f,\pp( |
    g) r r |
    r r f |
    a2.~ |
    a4 a2 |
    \barNumberCheck # 135
    % [13]
    as2.\pp~ |
    as4 r r |
    r c8-.\pp c-. as4 |
    c as c |
    g'2.\ppp~ |
    g |
    R2.*4 |
    R2.\fermata |
    \barNumberCheck # 146
}
>>


mvtIflII = <<
\mvtItimeline
\relative c'' {
    \transposition c
    % \time 4/4
    R1*3 |
    bes'2\pp r |
    R1*3 |
    \barNumberCheck # 8
    % \time 3/4
    R2.*8 |
    \barNumberCheck # 16
    % [1]
    R2.*11 |
    \barNumberCheck # 27
    % [2]
    R2.*4 |
    \partCombineChords
    as,2--\p as4--~ |
    as as2-- |
    as2 as4~ |
    as as2 |
    c2 c4~ |
    c c2 |
    es2 c4\>~ |
    \at 8. \! c c2 |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        R2. |
        r4 r d,\pp( |
        e) r r |
        r r d |
        e2.~ |
        e4 f2 |
        e2.~ |
        e4 r r |
        \barNumberCheck # 47
        % [4]
        R2. |
        r4 r r8 f\mp \Hso -\tweak to-barline ##f -\tweak minimum-length #8.0 \<( |
        g4\Hso\> f8-.\!) r r4 |
        R2.*2 |
        a2.\f |
        \partCombineSoloI
        <<
            \tag PARTS {
                R2.*2 |
            }
            \tag SCORE {
                R2. |
                R2. |
            }
        >>
        \barNumberCheck # 55
        % [5]
        R2.*6 |
        \partCombineChords
        <>\mf( \Rep 3 { e'8 gis } |
        e8-.) r r4 r |
        \barNumberCheck # 63
        % [6]
        a2.\mp~ |
        a~ |
        a4 \partCombineApart fis2 |
        e4( b2) |
        dis2. |
        dis( |
        e4) b2(~ |
        b e4) |
        \barNumberCheck # 71
        % [7]
        \partCombineChords
        a2.\f~ |
        a~ |
        a4 \partCombineApart fis2 |
        e4( b2) |
        dis2. |
        dis |
        \qat 16*5 \> cis(~ <>\! |
    % }
    \barNumberCheck # 78
    % \alternative {
        \partCombineChords
        cis4 b) r |
        % [8]
        r4 b\p r |
        r a r |
        r f r |
        r e r |
        r b' r |
        r a r |
        r fis r |
        r fis r |
        r f\> r |
        r f\! \partCombineApart r |
    % } {
        cis' -\shape #'((-2 . 0) (-1 . 0) (0 . 0) (0 . 0))( b) r |
    % }
    \barNumberCheck # 90
    % [9]
    \repeat unfold 2 {
        R2. |
        cis4.\pp( cis'8) cis4 |
        R2. |
        cis,4. cis'4( cis,8) |
    }
    R2.*8 |
    \barNumberCheck # 106
    % [10]
    R2.*11 |
    \barNumberCheck # 117
    % [11]
    R2.*4 |
    as2--\p as4--~ |
    as as2-- |
    as2 as4~ |
    as as2 |
    c2 c4~ |
    c c2 |
    es2 c4\>~ |
    \at 8. \! c c2 |
    \barNumberCheck # 129
    % [12]
    R2. |
    r4 r d,='\pp( |
    e) r r |
    r r d |
    e2.~ |
    e4 f2 |
    \barNumberCheck # 135
    % [13]
    d2.\pp~ |
    d4 r r |
    r as'8-.\pp as-. f4 |
    as f as |
    R2.*6 |
    R2.\fermata |
    \barNumberCheck # 146
}
>>


mvtIobI = <<
\mvtItimeline
\relative c'' {
    \transposition c
    % \time 4/4
    R1*3 |
    es2\pp r |
    R1 |
    r2 \acciaccatura f8 es-.\mp r r4 |
    R1 |
    \barNumberCheck # 8
    % \time 3/4
    R2.*4 |
    <>^"Solo" dis2->(~ _\markup\center-align{\dynamic p espr.} dis8 e) |
    cis2(~ cis8 gis) |
    b2.~ |
    b8 r r4 r |
    \barNumberCheck # 16
    % [1]
    R2.*11 |
    \barNumberCheck # 27
    % [2]
    <>^"Solo" d2.~ _\markup\center-align{\dynamic mf espr.} |
    d8 e( a4. d,8) |
    e2.~ |
    e8 d( cis d a b) |
    c4. r8 r4 |
    R2.*3 |
    as2\p as4~ |
    as as2 |
    c r4 |
    R2. |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        R2.*8 |
        \barNumberCheck # 47
        % [4]
        r4 a8-.\mp a-. b-. b-. |
        a4-. r r |
        r4 a8-. a-. b-. b-. |
        a4-> r r |
        r4 a8-.\< a-. b-. b-. |
        d2.\f |
        r4 a8-. a-. b-. -\tweak to-barline ##f \> b-. |
        a\! r r4 r |
        \barNumberCheck # 55
        % [5]
        R2.*6 |
        cis8\mf( e gis e cis e |
        gis-.) r r4 r |
        \barNumberCheck # 63
        % [6]
        b,2.\mf( |
        cis)~ |
        cis4 b( a) |
        gis( fis e) |
        gis2. |
        b2( a4) |
        gis( fis e~ |
        e) fis( gis) |
        \barNumberCheck # 71
        % [7]
        b2.\f( |
        cis)~ |
        cis4 b( a) |
        gis( fis e) |
        gis2. |
        fis2 b8-> fis-> |
        \at 16*5 \> e2.~ <>\! |
    % }
    \barNumberCheck # 78
    % \alternative {
        e2 e'8\p fis |
        % [8]
        g4. a8 g fis |
        g4. e8 c d |
        e4. d8 a b |
        c( b) c-. d-. e-. f?-. |
        g4. a8 g fis |
        g4. e8 c d |
        e4. d8 a c |
        R2. |
        e4.\p d8-. as-. c-. |
        R2. |
    % } {
        e,2\repeatTie r4 |
    % }
    \barNumberCheck # 90
    % [9]
    \at 2. \pp \repeat unfold 4 {
        R2. |
        gis4-. cis-. gis-. |
    }
    R2.*4 |
    <>^"Solo" dis'2->(~ _\markup\center-align{\dynamic p espr.} dis8 e) |
    cis2(~ cis8 gis) |
    b2.~ |
    b8 r r4 r |
    \barNumberCheck # 106
    % [10]
    R2.*11 |
    \barNumberCheck # 117
    % [11]
    <>^"Solo" d2.~ _\markup\center-align{\dynamic mf espr.} |
    d8 e( a4. d,8) |
    e2.~ |
    e8 d( cis d a b) |
    c4. r8 r4 |
    R2.*3 |
    as2\p as4~ |
    as as2 |
    c r4 |
    R2. |
    \barNumberCheck # 129
    % [12]
    R2.*6 |
    \barNumberCheck # 135
    % [13]
    f,2.\pp~ |
    f4 r r |
    r f'8-.\ppp f-. c4 |
    f c f |
    e2.\ppp~ |
    e |
    R2.*4 |
    R2.\fermata |
    \barNumberCheck # 146
}
>>


mvtIclrI = <<
\mvtItimeline
\relative c'' {
    \transposition a,
    % \time 4/4
    R1*3 |
    as'2\pp r |
    r2 r16 des,32\pp[( es] ges bes des es) r4 |
    r2 \acciaccatura des,8 bes-.\mp r r4 |
    R1 |
    \barNumberCheck # 8
    % \time 3/4
    <>^"Solo" a'2\p(~ a8 bes) |
    g2(~ g8 d) |
    f2.~ |
    f8 es( d es f fis) |
    fis4.\> <>\! r8 r4 |
    R2.*3 |
    \barNumberCheck # 16
    % [1]
    R2.*3 |
    r8 b,\pp( cis d e eis) |
    fis2(~ fis8 e~ |
    e d) r4 r |
    r r8 e( fis e) |
    b'( fis g dis fis e) |
    c2( dis8 e) |
    g( d es b d c) |
    a2.( |
    \barNumberCheck # 27
    % [2]
    bes8) r r4 r |
    R2.*3 |
    as2--\p as4--~ |
    as as2-- |
    as2 as4~ |
    as as2 |
    R2.*2 |
    b2\p b4\>~ |
    \at 8. \! b b2 |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        R2.*4 |
        g'2.\pp~ |
        g4 f4.( c8) |
        es2.~ |
        es4 r r |
        \barNumberCheck # 47
        % [4]
        r as,8-.\mp as-. bes-. bes-. |
        as4-. r r |
        r as8-. as-. bes-. bes-. |
        as4-> r r |
        r as8-.\< as-. bes-. bes-. |
        c2.\f |
        r4 as8-. as-. bes-. -\tweak to-barline ##f \> bes-. |
        as8\! r r4 r |
        \barNumberCheck # 55
        % [5]
        R2.*4 |
        r8 es-.\mp ges-. as-. ges-. es-. |
        r as-.\< ces-. des-. ces-. as-.\! |
        b\mf( d e d b d |
        e-.) r fis-.\mp -\tweak minimum-length #8.0 \< g-. a-. b-. <>\! |
        \barNumberCheck # 63
        % [6]
        fis2.\mf~ |
        fis~ |
        fis4 fis2 |
        d4( b2) |
        dis2. |
        es( |
        d4) b2(~ |
        b d4) |
        \barNumberCheck # 71
        % [7]
        fis2.\f~ |
        fis~ |
        fis4 fis2 |
        d4( b2) |
        dis2. |
        dis4 e,8->\f fis4.-> |
        \at 16*5 \> b2.~ <>\! |
    % }
    \barNumberCheck # 78
    % \alternative {
        b2 r4 |
        % [8]
        R2.*7 |
        g'4.\mp( f8 c es) |
        R2. |
        g4.\p( f8\> c es\!) |
    % } {
        b2\repeatTie r4 |
    % }
    \barNumberCheck # 90
    % [9]
    \at 2. \pp \repeat unfold 4 {
        R2. |
        e4-. b'-. e,-. |
    }
    <>^"Solo" a2\p(~ a8 bes) |
    g2(~ g8 d) |
    f2.~ |
    f8 es( d es f fis) |
    fis4.\> <>\! r8 r4 |
    R2.*3 |
    \barNumberCheck # 106
    % [10]
    R2.*3 |
    r8 b,\pp( cis d e eis) |
    fis2(~ fis8 e~ |
    e d) r4 r |
    r r8 e( fis e) |
    b'( fis g dis fis e) |
    c2( dis8 e) |
    g( d es b d c) |
    a2.( |
    \barNumberCheck # 117
    % [11]
    bes8) r r4 r |
    R2.*3 |
    as2--\p as4--~ |
    as as2-- |
    as2 as4~ |
    as as2 |
    R2.*2 |
    b2\p b4\>~ |
    \at 8. \! b b2 |
    \barNumberCheck # 129
    % [12]
    R2.*4 |
    g'2.\pp~ |
    g4 f4.( c8) |
    \barNumberCheck # 135
    % [13]
    es2.\pp~ |
    es4 r r |
    R2.*2 |
    es2.\ppp~ |
    es |
    R2.*2 |
    es,2.\ppp~ |
    es~ |
    es\fermata |
    \barNumberCheck # 146
}
>>


mvtIfgI = <<
\mvtItimeline
\relative c {
    \transposition c
    % \time 4/4
    \clef bass
    R1*7 |
    \barNumberCheck # 8
    % \time 3/4
    R2.*8 |
    \barNumberCheck # 16
    % [1]
    R2.*7 |
    e2.->\p |
    dis-> |
    d!-> |
    c-> |
    \barNumberCheck # 27
    % [2]
    b-> |
    R2. |
    a\p |
    R2.*9 |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        R2. |
        g'4.->\pp r8 r4 |
        R2.*6 |
        \barNumberCheck # 47
        % [4]
        g,4.\p r8 r4 |
        R2. |
        g4. r8 r4 |
        R2. |
        g4. r8 r4 |
        d''2\f a4 |
        R2.*2 |
        \barNumberCheck # 55
        % [5]
        R2.*4 |
        bes8-.\mp r r4 r |
        es8-. r r4 r |
        e,?2.\mf~ |
        e8 r r4 r |
        \barNumberCheck # 63
        % [6]
        b'8.-.\f[ cis16-. dis8-. cis-. b-. a-.] |
        b-. a-. gis-. fis-. e-. dis-. |
        cis-. b-. cis-. dis-. e-. fis-. |
        gis-. b4-> e8-. b-. gis-. |
        a8.-.[ b16-. d?8-. c?-. b-. a-.] |
        gis-. fis-. e-. dis-. e-. fis-. |
        gis-. e4 b e,8[~ |
        e] b'-. e-. gis-. b-. e-. |
        \barNumberCheck # 71
        % [7]
        b8.-.\f[ cis16-. dis8-. cis-. b-. a-.] |
        b-. a-. gis-. fis-. e-. dis-. |
        cis-. b-. cis-. dis-. e-. fis-. |
        gis-. b4-> e8-. b-. gis-. |
        a8.-.[ b16-. d?8-. c?-. b-. a-.] |
        r4 a8->\f b4.-> |
        e,8 fis \at 16 \> b fis e4~ <>\! |
    % }
    \barNumberCheck # 78
    % \alternative {
        e8 b e,4 r |
        % [8]
        <>\p \repeat unfold 7 { \at 4. \> g'2. <>\! | }
        g |
        R2.*2 |
    % } {
        e8\repeatTie b e,4 r |
    % }
    \barNumberCheck # 90
    % [9]
    R2.*16 |
    \barNumberCheck # 106
    % [10]
    R2.*7 |
    e'2.->\p |
    dis-> |
    d!-> |
    c-> |
    \barNumberCheck # 117
    % [11]
    b-> |
    R |
    a\p |
    R2.*9 |
    \barNumberCheck # 129
    % [12]
    R2. |
    g'4.->\pp r8 r4 |
    R2.*4 |
    \barNumberCheck # 135
    % [13]
    c2.\pp~ |
    c4 r r |
    R2.*8 |
    R2.\fermata |
    \barNumberCheck # 146
}
>>


mvtIglock = <<
\mvtItimeline
\relative c {
    \transposition c
    % \time 4/4
    \clef bass
    <>\pp \Rep 2 { <g' c>8 <bes es> } \Rep 2 { <g c> <bes es> } |
    r2 <bes c es>8\p r r4 |
    r2 <bes c es>8 r r4 |
    \clef treble
    r2 <<
        {
            f''=''16 f32( c f16-.\noBeam) r
        } \\ {
            <bes, c>16\pp <f bes> <bes c> r
        }
    >> r4 |
    R1 |
    <c es bes'>2\pp r |
    R1 |
    \barNumberCheck # 8
    % \time 3/4
    R2.*8 |
    \barNumberCheck # 16
    % [1]
    \at 4 \pp \repeat unfold 7 {
        r4 fis, r |
    }
    gis r r |
    R2.*3 |
    \barNumberCheck # 27
    % [2]
    R2.*6 |
    e4\pp r c |
    r d r |
    R2.*2 |
    as'4 r es |
    r f r \tag SCORE \breathe |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        r4 r g\ppp |
        R2. |
        r4 r g' |
        R2. |
        r4 g r |
        R2. |
        r4 r g |
        R2. |
        \barNumberCheck # 47
        % [4]
        d4\p r r |
        r f r |
        d r r |
        R2. |
        d4\p -\tweak minimum-length #5.0 \< r e <>\! |
        r f e -\tweak to-barline ##f \> |
        d\! r r |
        R2. |
        \barNumberCheck # 55
        % [5]
        R2.*6 |
        <>\mp( \Rep 3 { <e, b'>8 <gis cis> } |
        <e b'>8-.) r r4 r |
        \barNumberCheck # 63
        % [6]
        R2.*8 |
        \barNumberCheck # 71
        % [7]
        b'4\f r r |
        cis r r |
        r b a |
        gis fis e |
        gis r r |
        r fis b8 fis |
        e4 r r |
    % }
    \barNumberCheck # 78
    % \alternative {
        R2. |
        % [8]
        R2.*4 |
        g'4\p r r |
        g r r |
        R2.*4 |
    % } {
        R2. |
    % }
    \barNumberCheck # 90
    % [9]
    <>\pp \repeat unfold 4 {
        <cis,, fis>4 <dis gis> <cis fis> |
        <gis e'> r r |
    }
    R2.*8 |
    \barNumberCheck # 106
    % [10]
    \at 4 \pp \repeat unfold 7 { r4 fis'=' r | }
    gis r r |
    R2.*3 |
    \barNumberCheck # 117
    % [11]
    R2.*6 |
    e4\pp r c |
    r d r |
    R2.*2 |
    as'4 r es |
    r f r |
    \barNumberCheck # 129
    % [12]
    r4 r g\ppp |
    R2. |
    r4 r g' |
    R2. |
    r4 g r |
    R2. |
    \barNumberCheck # 135
    % [13]
    c,4\pp r r |
    R2. |
    d4 r r |
    R2. |
    c'4\ppp r r |
    R2.*5 |
    R2.\fermata |
    \barNumberCheck # 146
}
>>


mvtItriang = <<
\mvtItimeline
{
    % \time 4/4
    R1*7 |
    \barNumberCheck # 8
    % \time 3/4
    <>\pp \repeat unfold 3 { c4 r r | }
    R2.*2 |
    \repeat unfold 2 { c4 r r | }
    R2. |
    \barNumberCheck # 16
    % [1]
    R2.*11 |
    \barNumberCheck # 27
    % [2]
    R2.*12 |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        <>\pp \repeat unfold 8 { c4 r r | }
        \barNumberCheck # 47
        % [4]
        R2.*8 |
        \barNumberCheck # 55
        % [5]
        <>\pp \repeat unfold 6 { c4 r r | }
        R2.*2 |
        \barNumberCheck # 63
        % [6]
        R2.*8 |
        \barNumberCheck # 71
        % [7]
        R2.*7 |
    % }
    \barNumberCheck # 78
    % \alternative {
        R2. |
        % [8]
        <>\p \repeat unfold 4 { c4 r r | }
        R2.*2 |
        <>\p \repeat unfold 2 { c4 r r | }
        R2.*2 |
    % } {
        R2. |
    % }
    \barNumberCheck # 90
    % [9]
    R2.*8 |
    <>\pp \repeat unfold 3 { c4 r r | }
    R2.*2 |
    \repeat unfold 2 { c4 r r | }
    R2. |
    \barNumberCheck # 106
    % [10]
    R2.*11 |
    \barNumberCheck # 117
    % [11]
    R2.*12 |
    \barNumberCheck # 129
    % [12]
    <>\pp \repeat unfold 6 { c4 r r | }
    \barNumberCheck # 135
    % [13]
    R2.*10 |
    R2.\fermata |
    \barNumberCheck # 146
}
>>


mvtIhpRH = <<
\mvtItimeline
\relative c'' {
    \transposition c
    % \time 4/4
    \repeat unfold 14 { \Rep 2 { f,8 es } } |
    \barNumberCheck # 8
    % \time 3/4
    R2.*8 |
    \barNumberCheck # 16
    % [1]
    r4 <gis, e'>\pp <ais e'> |
    r <fis dis'> <b dis> |
    r4 <gis e'> <cis e> |
    r <fis, dis'> <b dis> |
    r4 <gis e'> <ais e'> |
    r <fis dis'> <b dis> |
    r4 <e, gis cis> <\Fa gis cis e> |
    <cis gis'> r r |
    R2.*3 |
    \barNumberCheck # 27
    % [2]
    R2.*2 |
    <c! f! a e'>4\arpeggio r r |
    R2.*9 |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        \repeat unfold 3 {
            R2. |
            r4 r <d f>-> |
        }
        R2.*2 |
        \barNumberCheck # 47
        % [4]
        R2.*8 |
        \barNumberCheck # 55
        % [5]
        \repeat unfold 2 {
            r8 c es f es c |
        }
        \repeat unfold 2 {
            r8 f as bes as f |
        }
        R2.*2 |
        s2. |
        gis4 r r |
        \barNumberCheck # 63
        % [6]
        s2.*8 |
        \barNumberCheck # 71
        % [7]
        s2.*5 |
        s2 \voiceTwo <b, fis' a>4 \oneVoice |
        s2. |
    % }
    \barNumberCheck # 78
    % \alternative {
        s2. |
        % [8]
        R2.*10 |
    % } {
        R2. |
    % }
    \barNumberCheck # 90
    % [9]
    <>\p \repeat unfold 4 {
        <cis'='' fis>4 <dis gis> <cis fis> |
        <gis cis> <cis gis'> <gis cis> |
    }
    R2.*8 |
    \barNumberCheck # 106
    % [10]
    r4 <gis,= e'>\pp <ais e'> |
    r <fis dis'> <b dis> |
    r4 <gis= e'> <cis e> |
    r <fis, dis'> <b dis> |
    r4 <gis= e'> <ais e'> |
    r <fis dis'> <b dis> |
    r <e, gis cis> <\Fa gis cis e> |
    <cis gis'> r r |
    R2.*3 |
    \barNumberCheck # 117
    % [11]
    R2.*2 |
    <c!=' f! a e'>4\arpeggio r r |
    R2.*9 |
    \barNumberCheck # 129
    % [12]
    \repeat unfold 3 {
        R2. |
        r4 r <d f>-> |
    }
    \barNumberCheck # 135
    % [13]
    R2. |
    r4 c\pp as' |
    R2.*8 |
    R2.\fermata |
    \barNumberCheck # 146
}
>>


mvtIhpDyn = <<
\mvtItimeline
{
    % \time 4/4
    <>\pp s1*7 |
    \barNumberCheck # 8
    % \time 3/4
    s2.*8 |
    \barNumberCheck # 16
    % [1]
    s2.*11 |
    \barNumberCheck # 27
    % [2]
    s2.*2 |
    <>\p s2.*10 |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        s2.*8 |
        \barNumberCheck # 47
        % [4]
        s2.*8 |
        \barNumberCheck # 55
        % [5]
        s2.*8 |
        \barNumberCheck # 63
        % [6]
        s2.*8 |
        \barNumberCheck # 71
        % [7]
        s2.*6 |
        s4 <>\> s4.. <>\! s16 |
    % }
    \barNumberCheck # 78
    % \alternative {
        s2. |
        % [8]
        s2.*10 |
    % } {
        s2. |
    % }
    \barNumberCheck # 90
    % [9]
    s2.*16 |
    \barNumberCheck # 106
    % [10]
    s2.*11 |
    \barNumberCheck # 117
    % [11]
    s2.*2 |
    <>\p s2.*10 |
    \barNumberCheck # 129
    % [12]
    s2.*6 |
    \barNumberCheck # 135
    % [13]
    s2.*11 |
    \barNumberCheck # 146
}
>>


mvtIhpLH = <<
\mvtItimeline
\relative c {
    \transposition c
    % \time 4/4
    \clef bass
    \repeat unfold 12 { \Rep 2 { c'8 bes } } |
    R1 |
    \barNumberCheck # 8
    % \time 3/4
    R2.*8 |
    \barNumberCheck # 16
    % [1]
    R2.*6 |
    fis,4 r r |
    <e' ais> r r |
    R2.*3 |
    \barNumberCheck # 27
    % [2]
    R2.*2 |
    <a, d! f! a>4\arpeggio r r |
    R2.*7 |
    r4 <f' as c>\mp r |
    r r <f as c>\p \tag SCORE \breathe |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        <>^\markup\center-align{\dynamic p deutlich!} \repeat unfold 2 {
            r4 c,-> g'-> |
            g'-> r r |
        }
        r4 g,,-> g'-> |
        g'-> r r |
        r4 c,,-> g'-> |
        g'-> r r |
        \barNumberCheck # 47
        % [4]
        R2.*6 |
        <g,, g'>4^\mf r r |
        R2. |
        \barNumberCheck # 55
        % [5]
        <>^\mf \repeat unfold 2 {
            bes''=4 r r |
        }
        \repeat unfold 2 {
            es r r |
        }
        R2.*2 |
        e,,!8^\mf b'! e! gis \RH b! e! |
        \LH R2. |
        \barNumberCheck # 63
        % [6]
        #(ly:expect-warning-times 5 "no viable initial configuration found: may not find good beam slope")
        b,=,16^\mf dis fis a b \RH dis fis a b dis fis a |
        r a fis dis b a fis dis \LH b a fis dis |
        b dis fis a b \RH dis fis a b dis fis a |
        \LH b,,,=, e gis b \RH e gis b e gis b e gis |
        r4 gis,16 dis c! a \LH gis dis c a |
        b, fis' a c! \RH dis fis a dis dis fis a dis |
        e b gis e b gis e b b'' gis! e b |
        \stemUp gis e \LH b gis \RH \stemNeutral gis''='' e b gis \LH e b gis e |
        \barNumberCheck # 71
        % [7]
        b^\f dis fis a b \RH dis fis a b dis fis a |
        r a fis dis b a fis dis \LH b a fis dis |
        b dis fis a b \RH dis fis a b dis fis a |
        \LH b,,,=, e gis b \RH e gis b e gis b e gis |
        r4 gis,16 dis c! a \LH gis dis c! a |
        b, fis' a cis \RH dis fis a dis \once \voiceOne <dis fis b>4 |
        e'16 cis b gis e cis b gis \LH e cis b gis |
    % }
    \barNumberCheck # 78
    % \alternative {
        e8 b e,4 r |
        % [8]
        R2.*8 |
        r4 <f'= as c>4 ^\markup\center-align{\dynamic mp deutlich} r |
        r q^\p r |
    % } {
        e8 b e,4 r |
    % }
    \barNumberCheck # 90
    % [9]
    R2.*16 |
    \barNumberCheck # 106
    % [10]
    R2.*6 |
    fis=,4 r r |
    <e' ais> r r |
    R2.*3 |
    \barNumberCheck # 117
    % [11]
    R2.*2 |
    <a,=, d! f! b>4\arpeggio r r |
    R2.*7 |
    r4 <f'= as c>\mp r |
    r r q\p |
    \barNumberCheck # 129
    % [12]
    <> ^\markup\center-align{\dynamic p deutlich!} \repeat unfold 2 {
        r c,=,4-> g'-> |
        g'-> r r |
    }
    r g,,-> g'-> |
    g'-> r r |
    \barNumberCheck # 135
    % [13]
    R2.*4 |
    r4 c,,=,^\p g' |
    g' r r |
    r c,,^\pp g' |
    g' r r |
    R2.*2 |
    R2.\fermata |
    \barNumberCheck # 146
}
>>


mvtIvlnI = <<
\mvtItimeline
\relative c'' {
    \transposition c
    % \time 4/4
    \arpeggioBracket
    \override Arpeggio.positions = #regular-arp
    <>^\Dmit
    R1 |
    \repeat unfold 2 { f2\pp -\tweak minimum-length #7.0 \<( bes8\mf) r r4 | }
    R1*3 |
    <>-\offset X-offset #-3.5 ^\markup\right-align\Get cis1_\pp |
    \barNumberCheck # 8
    % \time 3/4
    r4 <>^\Zus a,\p r |
    r b r |
    r \at 4 \> g2\Hxso\< <>\! |
    R2. |
    r4 fis r |
    r gis r |
    r f? r |
    r8 ais\pp( cis b ais b) |
    \barNumberCheck # 16
    % [1]
    dis2(~ dis8 cis~ |
    cis) b( ais b cis b) |
    dis( cis bis cis b ais~ |
    ais) gis( ais b cis cisis) |
    dis2(~ dis8 cis~ |
    cis) b( ais b cis b) |
    dis( cis bis cis dis cis) |
    gis'2.(~ |
    gis8 fis dis e bis cis) |
    e2.~ |
    e8 dis( b? c? gis a) |
    \barNumberCheck # 27
    % [2]
    g2.-> |
    R2. |
    <c, a'>\p |
    R |
    r4 <>^\PZ c\pp r |
    r r c |
    r c r |
    r r c |
    r c r |
    r r c |
    R2.*2 |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        g''2.\pp~ |
        g4 <a, a'>4.\arpeggio( f'8) |
        g2.~ |
        g4 f8( e f d) |
        e2.~ |
        e4 d4.( a8) |
        c2.~ |
        c4 g8( a b c) |
        \barNumberCheck # 47
        % [4]
        d2.\p~ |
        d4 f4.( c8) |
        d2.~ |
        d4 g,8-.( a-. b-. c-.) |
        \at 4 \< d2( e4) <>\! |
        g( f e-.) |
        \at 8 \> d2.~ <>\! |
        d8 r r4 r |
        \barNumberCheck # 55
        % [5]
        <>^"Until HERE"
        r8 f,\pp \Hso -\tweak minimum-length #7.0 \<~ \at 4 \! f4.\Hso\> r8 |
        r8 f\Hso\<~ \at 4 \! f4.\Hso\> r8 |
        r8 bes\Hso\<~ \at 4 \! bes4.\Hso\> r8 |
        r8 bes\Hso\<~ \at 4 \! bes4.\Hso\> r8 |
        r8 f\Hso\<~ \at 4 \! f4.\Hso\> r8 |
        r8 bes\Hso\<~ \at 4 \! bes4.\Hso\> r8 |
        b!8\mf( cis e cis b cis |
        e\noBeam) cis-.\mp -\tweak minimum-length #8.0 \< dis-. e-. fis-. gis-. \! |
        \barNumberCheck # 63
        % [6]
        b2.( _\markup\center-align{\dynamic mf espr.} |
        cis)~ |
        cis4 b( a) |
        gis( fis e) |
        gis2. |
        b2( a4) |
        gis( fis e~ |
        e) fis( gis) |
        \barNumberCheck # 71
        % [7]
        b2.( _\markup\center-align{\dynamic f espr.} |
        cis)~ |
        cis4 b( a) |
        gis( fis e) |
        gis2. |
        fis |
        \at 4 \> e~ <>\! |
    % }
    \barNumberCheck # 78
    % \alternative {
        e2 r4 |
        % [8]
        r4 f,4.\pp r8 |
        r4 g4. r8 |
        r4 d4. r8 |
        r4 g4. r8 |
        r4 f4. r8 |
        r4 g4. r8 |
        r4 <c, d>4. r8 |
        r4 q4. r8 |
        R2.*2 |
    % } {
        e'2\repeatTie e8-.\pp( e-.) |
    % }
    \barNumberCheck # 90
    % [9]
    \repeat unfold 2 {
        a4 a8-. a-. a-.( a-.) |
        e4. e'8\noBeam e,( e'-.) |
        a,4 a8-. a-. a-.( a-.) |
        e4. e'8\noBeam( e,4-.) |
    }
    r4 a,\p r |
    r b r |
    r \at 4 \> g2\Hxso\< <>\! |
    R2. |
    r4 fis r |
    r gis r |
    r f? r |
    r8 ais\pp( cis b ais b) |
    \barNumberCheck # 106
    % [10]
    dis2(~ dis8 cis~ |
    cis) b( ais b cis b) |
    dis( cis bis cis b ais~ |
    ais) gis( ais b cis cisis) |
    dis2(~ dis8 cis!~ |
    cis) b( ais b cis b) |
    dis( cis bis cis dis cis) |
    gis'2.(~ |
    gis8 fis dis e bis cis) |
    e2.~ |
    e8 dis( b? c? gis a) |
    \barNumberCheck # 117
    % [11]
    g?2.-> |
    R |
    <c, a'>\p |
    R |
    r4 <>^\PZ c\pp r |
    r r c |
    r c r |
    r r c |
    r c r |
    r r c |
    R2.*2 |
    \barNumberCheck # 129
    % [12]
    g''2.\pp~ |
    g4 <a, a'>4.\arpeggio( f'8) |
    g2.~ |
    g4 f8( e f d) |
    e2.~ |
    e4 d4.( a8) |
    \barNumberCheck # 135
    % [13]
    R2. |
    r4 <>-\offset X-offset #1.5 ^\markup\right-align \Get c'2_\pp |
    <>-\offset X-offset #-0.5 ^\markup\left-align \Zus d2.\ppp~ |
    d |
    <>-\offset X-offset #-0.5 ^\markup\left-align\Get \ottava 1 c'~ |
    c \ottava 0 |
    R2.*2 |
    c,2.~ |
    <>_"morendo" c~ |
    c\fermata |
    \barNumberCheck # 146
}
>>


mvtIvlnIhII = <<
\mvtItimeline
\relative c'' {
    \transposition c
    % \time 4/4
    \tag PARTS \boring
    \partCombineUnisono
    \quoteDuring mvtIvlnI {
        s1*6 |
    }
    \tag PARTS \tricky
    \PC_AUTO_CHORDS
    \Q <>\pp-\offset X-offset #-3.5 ^\markup\right-align\Get a'1 |
    \barNumberCheck # 8
    % \time 3/4
    \tag PARTS \boring
    \partCombineUnisono
    \quoteDuring mvtIvlnI {
        s2.*8 |
        \barNumberCheck # 16
        % [1]
        s2.*11 |
        \barNumberCheck # 27
        % [2]
        s2.*12 |
        \barNumberCheck # 39
        % \repeat volta 2 {
            % [3]
            s2.*8 |
            \barNumberCheck # 47
            % [4]
            s2.*8 |
            \barNumberCheck # 55
            % [5]
            s2.*8 |
            \barNumberCheck # 63
            % [6]
            s2.*8 |
            \barNumberCheck # 71
            % [7]
            s2.*7 |
        % }
        \barNumberCheck # 78
        % \alternative {
            s2. |
            % [8]
            s2.*10 |
        % } {
            s2. |
        % }
        \barNumberCheck # 90
        % [9]
        s2.*16 |
        \barNumberCheck # 106
        % [10]
        s2.*11 |
        \barNumberCheck # 117
        % [11]
        s2.*12 |
        \barNumberCheck # 129
        % [12]
        s2.*6 |
        \barNumberCheck # 135
        % [13]
        s2.*1 |
    }
    \tag PARTS \tricky
    \PC_AUTO_CHORDS
    r4 \Q <>\pp-\offset X-offset #1.5 ^\markup\right-align \Get as2 |
    \tag PARTS \boring
    \partCombineUnisono
    \quoteDuring mvtIvlnI {
        s2.*2 |
    }
    \tag PARTS \tricky
    \PC_AUTO_CHORDS
    \Q <>-\offset X-offset #-0.5 ^\markup\left-align\Get \ottava 1 g'2.~ |
    g \ottava 0 |
    R2.*2 |
    g,2.~ |
    \Q <>_"morendo" g~ |
    g\fermata |
    \barNumberCheck # 146
}
>>


mvtIvlnII = <<
\mvtItimeline
\relative c'' {
    \transposition c
    % \time 4/4
    \arpeggioBracket
    \override Arpeggio.positions = #regular-arp
    <>^\Dmit
    R1 |
    c2\pp -\tweak minimum-length #7.0 \<( f8\mf) r r4 |
    c2\pp -\tweak minimum-length #7.0 \<( f8\mf) r r4 |
    R1*3 |
    <>-\offset X-offset #-3.5 ^\markup\right-align\Get ges1\pp |
    \barNumberCheck # 8
    % \time 3/4
    r4 <>^\Zus fis,\p r |
    r g r |
    r \at 4 \> es2\Hxso\< <>\! |
    R2. |
    r4 dis r |
    r e r |
    r des r |
    R2. |
    \barNumberCheck # 16
    % [1]
    r4 e2\pp |
    dis2. |
    r4 e2~ |
    e4 dis2 |
    r4 e2 |
    dis2. |
    gis |
    cis,-> |
    cis-> |
    c!-> |
    a-> |
    \barNumberCheck # 27
    % [2]
    e'-> |
    R |
    <a, f'>\p |
    R |
    r4 <>^\PZ as\pp r |
    r r as |
    r as r |
    r r as |
    r as r |
    r r as |
    R2.*2 |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        <>^\AC <c' e>2.\pp\arpeggio~ |
        q4 <d f>2\arpeggio |
        <c e>2.\arpeggio~ |
        q4 c2 |
        c2.~ |
        c4 <> -\offset X-offset #1.5 ^\markup\right-align\Get a2 |
        g2.~ |
        g4 r r |
        \barNumberCheck # 47
        % [4]
        <> -\offset X-offset #-0.5 ^\markup\left-align\Zus d2.\p~ |
        d4 f4.( c8) |
        d2.~ |
        d4 r r |
        \at 4 \< d2( e4) <>\! |
        g( f e-.) |
        \at 8 \> d2.~ <>\! |
        d8 r r4 r |
        \barNumberCheck # 55
        % [5]
        r8 es\pp \Hso -\tweak minimum-length #7.0 \<~ \at 4 \! es4.\Hso\> r8 |
        r8 es\Hso\<~ \at 4 \! es4.\Hso\> r8 |
        r8 as\Hso\<~ \at 4 \! as4.\Hso\> r8 |
        r8 as\Hso\<~ \at 4 \! as4.\Hso\> r8 |
        r8 es\Hso\<~ \at 4 \! es4.\Hso\> r8 |
        r8 as\Hso\<~ \at 4 \! as4.\Hso\> r8 |
        e8\mf( gis b gis e gis |
        b) r r4 r |
        \barNumberCheck # 63
        % [6]
        <>^\Get a'2.:32\mp~ |
        a:~ |
        a4: fis2: |
        e4: b2: |
        dis2.: |
        dis: |
        e4: b2:~ |
        b: e4: |
        \barNumberCheck # 71
        % [7]
        a2.:\f~ |
        a:~ |
        a4: fis2: |
        e4: b2: |
        dis2.: |
        dis: |
        \at 4 \> b:~ <>\! |
    % }
    \barNumberCheck # 78
    % \alternative {
        b2 r4 |
        % [8]
        r4 <>^\Zus d,4.\pp r8 |
        r4 e4. r8 |
        r4 c4. r8 |
        r4 <c e>4.\arpeggio r8 |
        r4 d4. r8 |
        r4 e4. r8 |
        r4 a,4. r8 |
        r4 a4. r8 |
        R2.*2 |
    % } {
        <>-\offset X-offset #2.5 ^\PGet b'2\repeatTie r4 |
    % }
    \barNumberCheck # 90
    % [9]
    \at 2. \pp \at 2. -\offset X-offset #-2.0 ^\markup\left-align\Zus \repeat unfold 2 {
        R2. |
        cis4. cis'8\noBeam cis,( cis'-.) |
        R2. |
        cis,4. cis'8( cis,4-.) |
    }
    r4 fis,\p r |
    r g r |
    r \at 4 \> es2\Hxso\< <>\! |
    R2. |
    r4 dis r |
    r e r |
    r des r |
    R2. |
    \barNumberCheck # 106
    % [10]
    r4 e2\pp |
    dis2. |
    r4 e2~ |
    e4 dis2 |
    r4 e2 |
    dis2. |
    gis |
    cis,-> |
    cis-> |
    c!-> |
    a-> |
    \barNumberCheck # 117
    % [11]
    e'-> |
    R2. |
    <>^\AC <a, f'>2.\p |
    R |
    r4 <>^\PZ as\pp r |
    r r as |
    r as r |
    r r as |
    r as r |
    r r as |
    R2.*2 |
    \barNumberCheck # 129
    % [12]
    <>^\AC <c' e>2.\arpeggio~ |
    q4 <d f>2\arpeggio |
    <c e>2.\arpeggio~ |
    q4 c2 |
    c2.~ |
    c4 <>-\offset X-offset #1.5 ^\markup\right-align\Get a2 |
    \barNumberCheck # 135
    % [13]
    R2. |
    r4 f'2_\pp |
    <> -\offset X-offset #-0.5 ^\markup\left-align\Zus d2.\ppp~ |
    d |
    <>-\offset X-offset #-0.5 ^\markup\left-align\Get e'~ |
    e |
    g,_\ppp~ |
    g |
    e~ |
    <>_"morendo" e~ |
    e\fermata |
    \barNumberCheck # 146
}
>>


mvtIvlnIIhII = <<
\mvtItimeline
\relative c'' {
    \transposition c
    % \time 4/4
    % \tag PARTS \boring
    \partCombineUnisono
    \quoteDuring mvtIvlnII {
        s1*6 |
    }
    % \tag PARTS \tricky
    \PC_AUTO_CHORDS
    \Q <> -\offset X-offset #-3.5 ^\markup\right-align\Get es1\pp |
    \barNumberCheck # 8
    % \time 3/4
    % \tag PARTS \boring
    \partCombineUnisono
    \quoteDuring mvtIvlnII {
        s2.*8 |
        \barNumberCheck # 16
        % [1]
        s2.*11 |
        \barNumberCheck # 27
        % [2]
        s2.*12 |
        \barNumberCheck # 39
        % \repeat volta 2 {
            % [3]
            s2.*5 |
            s4
        }
            % \tag PARTS \tricky
            \PC_AUTO_CHORDS
            \Q <> -\offset X-offset #1.5 ^\markup\right-align\Get f,2 |
        e2.~ |
        e4 r r |
        \barNumberCheck # 47
        % [4]
        % \tag PARTS \boring
        \partCombineUnisono
        \quoteDuring mvtIvlnII {
            s2.*8 |
            \barNumberCheck # 55
            % [5]
            s2.*8 |
        }
        \barNumberCheck # 63
        % [6]
        % \tag PARTS \tricky
        \PC_AUTO_CHORDS
        \Q <>^\Get dis'2.:32\mp~ |
        dis:~ |
        dis4: dis2: |
        b4: gis2: |
        bis2.: |
        c: |
        b4: gis2:~ |
        gis: b4: |
        \barNumberCheck # 71
        % [7]
        dis2.:32\f~ |
        dis:~ |
        dis4: dis2: |
        b4: gis2: |
        bis2.: |
        a: |
        \at 4 \> gis2.:~ <>\! |
    % }
    \barNumberCheck # 78
    % \alternative {
        gis2 r4 |
        % [8]
        % \tag PARTS \boring
        \partCombineUnisono
        \quoteDuring mvtIvlnII {
            s2.*10 |
        % } {
        }
        % \tag PARTS \tricky
        \PC_AUTO_CHORDS
        \Q <>-\offset X-offset #2.5 ^\PGet gis='2\repeatTie r4 |
    % }
    \barNumberCheck # 90
    % [9]
    % \tag PARTS \boring
    \partCombineUnisono
    \quoteDuring mvtIvlnII {
        s2.*16 |
        \barNumberCheck # 106
        % [10]
        s2.*11 |
        \barNumberCheck # 117
        % [11]
        s2.*12 |
        \barNumberCheck # 129
        % [12]
        s2.*5 |
        s4
    }
        % \tag PARTS \tricky
        \PC_AUTO_CHORDS
        \Q <>^\Get f2 |
    \barNumberCheck # 135
    % [13]
    \partCombineUnisono
    R2. |
    \PC_AUTO_CHORDS
    r4 \Q <>\pp d'2 |
    % \tag PARTS \boring
    \partCombineUnisono
    \quoteDuring mvtIvlnII {
        s2.*2 |
    }
    % \tag PARTS \tricky
    \PC_AUTO_CHORDS
    \Q <>-\offset X-offset #-0.5 ^\markup\left-align\Get c'2.~ |
    c |
    \Q <>\ppp e,~ |
    e |
    c~ |
    \Q <>_"morendo" c~ |
    c\fermata |
    \barNumberCheck # 146
}
>>


mvtIvla = <<
\mvtItimeline
\relative c' {
    \transposition c
    % \time 4/4
    \clef alto
    \arpeggioBracket
    \override Arpeggio.positions = #regular-arp
    <>^\Dmit
    R1 |
    bes'2\pp -\tweak minimum-length #7.0 \<( es8\mf) r r4 |
    bes2\pp -\tweak minimum-length #7.0 \<( es8\mf) r r4 |
    R1*4 |
    \barNumberCheck # 8
    % \time 3/4
    r4 c,\p r |
    r <b e>\arpeggio r |
    r \at 4 \> <g d'>2\arpeggio\Hxso\< <>\! |
    R2. |
    r4 cis r |
    r cis r |
    r b r |
    R2. |
    \barNumberCheck # 16
    % [1]
    r4 gis\pp( ais) |
    r fis( b) |
    r gis( cis) |
    r fis,( b) |
    r gis( ais) |
    r fis( b) |
    r e,( gis) |
    ais2.-> |
    a!-> |
    a-> |
    fis-> |
    \barNumberCheck # 27
    % [2]
    r4 <>^\PZ e\p d' |
    R2. |
    <>^\AC f,2.\p |
    R2. |
    r4 <>^\PZ f\pp r |
    r r f |
    r f r |
    r r f |
    r f r |
    r r f |
    R2.*2 |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        <g' a>2.\pp\arpeggio~ |
        q4 b2 |
        q2.\arpeggio~ |
        q4 a2 |
        <e a>2.\arpeggio~ |
        q4 r <>^\PZ <b d> |
        r4 <>^\AC <c, g'>2~ |q4 r r |
        \barNumberCheck # 47
        % [4]
        r <>^\PZ d\p b' |
        r r d |
        r d, b' |
        R2.
        r4 d,\< b' <>\! |
        <a d> r r |
        r d,\> b'\! |
        R2. |
        \barNumberCheck # 55
        % [5]
        r8 <>^\AC c\pp \Hso-\tweak minimum-length #7.0 \<~ \at 4 \! c4.\Hso\> r8 |
        r8 c\Hso\<~ \at 4 \! c4.\Hso\> r8 |
        r8 f\Hso\<~ \at 4 \! f4.\Hso\> r8 |
        r8 f\Hso\<~ \at 4 \! f4.\Hso\> r8 |
        r8 c\Hso\<~ \at 4 \! c4.\Hso\> r8 |
        r8 f\Hso\<~ \at 4 \! f4.\Hso\> r8 |
        b,2.\mf~ |
        b8 r r4 r |
        \barNumberCheck # 63
        % [6]
        b'2.( _\markup\center-align{\dynamic mf espr.} |
        cis)~ |
        cis4 b( a) |
        gis( fis e) |
        gis2. |
        b2( a4) |
        gis( fis e~ |
        e) fis( gis) |
        \barNumberCheck # 71
        % [7]
        b2.( _\markup\center-align{\dynamic f espr.} |
        cis)~ |
        cis4 b( a) |
        gis( fis e) |
        gis2. |
        fis |
        \at 4 \> e~ <>\! |
    % }
    \barNumberCheck # 78
    % \alternative {
        e2 r4 |
        % [8]
        <>\pp^\PZ \repeat unfold 8 { g,4 r r | }
        R2.*2 |
    % } {
        e'2\repeatTie r4 |
    % }
    \barNumberCheck # 90
    % [9]
    \at 2. \pp \at 2. ^\markup{Flag.} \repeat unfold 4 {
        R2. |
        cis'=''4.\flageolet r |
    }
    r4 c,\p r |
    r <b e>\arpeggio r |
    r \at 4 \> <g d'>2\arpeggio\Hxso\< <>\! |
    R2. |
    r4 cis r |
    r cis r |
    r b r |
    R2. |
    \barNumberCheck # 106
    % [10]
    r4 gis\pp( ais) |
    r fis( b) |
    r gis( cis) |
    r fis,( b) |
    r gis( ais) |
    r fis( b) |
    r e,( gis) |
    ais2.-> |
    a!-> |
    a-> |
    fis-> |
    \barNumberCheck # 117
    % [11]
    r4 <>^\PZ e\p d' |
    R2. |
    <>^\AC f,2.\p |
    R |
    r4 <>^\PZ f\pp r |
    r r f |
    r f r |
    r r f |
    r f r |
    r r f |
    R2.*2 |
    \barNumberCheck # 129
    % [12]
    <g' a>2.\arpeggio\pp~ |
    q4 b2 |
    q2.\arpeggio~ |
    q4 a2 |
    <e a>2.\arpeggio~ |
    q4 r <>^\PZ <b d> |
    \barNumberCheck # 135
    % [13]
    R2. |
    r4 <>^\AC c'2\pp |
    R2.*4 |
    <> -\offset X-offset #-0.5 ^\markup\left-align\Get c2._\ppp~ |
    c |
    g~ |
    <>_"morendo" g~ |
    g\fermata |
    \barNumberCheck # 146
}
>>


mvtIvlahII = <<
\mvtItimeline
\relative c' {
    \transposition c
    % \time 4/4
    \clef alto
    <>^\Dmit
    \tag PARTS \boring
    \partCombineUnisono
    \quoteDuring mvtIvla {
        s1*7 |
        \barNumberCheck # 8
        % \time 3/4
        s2.*8 |
        \barNumberCheck # 16
        % [1]
        s2.*11 |
        \barNumberCheck # 27
        % [2]
        s2.*12 |
        \barNumberCheck # 39
        % \repeat volta 2 {
            % [3]
            s2.*8 |
            \barNumberCheck # 47
            % [4]
            s2.*8 |
            \barNumberCheck # 55
            % [5]
            s2.*8 |
            \barNumberCheck # 63
            % [6]
            s2.*8 |
            \barNumberCheck # 71
            % [7]
            s2.*7 |
        % }
        \barNumberCheck # 78
        % \alternative {
            s2. |
            % [8]
            s2.*10 |
        % } {
            s2. |
        % }
        \barNumberCheck # 90
        % [9]
        s2.*16 |
        \barNumberCheck # 106
        % [10]
        s2.*11 |
        \barNumberCheck # 117
        % [11]
        s2.*12 |
        \barNumberCheck # 129
        % [12]
        s2.*6 |
        \barNumberCheck # 135
        % [13]
        s2.*6 |
    }
    \tag PARTS \tricky
    \PC_AUTO_CHORDS
    \Q <>\ppp -\offset X-offset #-0.5 ^\markup\left-align\Get a'2.~ |
    a |
    e~ |
    \Q <>_"morendo" e~ |
    e\fermata |
    \barNumberCheck # 146
}
>>


mvtIvc = <<
\mvtItimeline
\relative c {
    \transposition c
    % \time 4/4
    \clef bass
    \arpeggioBracket
    \override Arpeggio.positions = #regular-arp
    <>^\Dmit
    R1*7 |
    \barNumberCheck # 8
    % \time 3/4
    c4\p a' r |
    b, g' r |
    a, \at 4 \> es'2\Hxso\< <>\! |
    R2. |
    a,4 a' r |
    gis, gis' r |
    g, g' r |
    R2. |
    \barNumberCheck # 16
    % [1]
    <>\pp \repeat unfold 7 { fis,2.-> | }
    gis'-> |
    fis-> |
    fis-> |
    e-> |
    \barNumberCheck # 27
    % [2]
    r4 <>^\PZ e\p d' |
    R2. |
    <>^\AC d,2.\p |
    R2. |
    <>^\PZ f4\pp r r |
    c r r |
    f r r |
    c r r |
    as' r r |
    c, r r |
    f-\tweak to-barline ##f \> r r |
    c\! r r |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        r4 <>^\AC <c,=, g'>2\pp\arpeggio~ |
        q4 r r |
        r q2\arpeggio~ |
        q4 r r |
        r r <>^\PZ g'\pp |
        g' r r |
        r r g, |
        g' r r |
        \barNumberCheck # 47
        % [4]
        r4 <>^\PZ d\p b' |
        r r d |
        r d, b' |
        R2. |
        r4 d,\< b' <>\! |
        d, r r |
        r d\> b'\! |
        R2. |
        \barNumberCheck # 55
        % [5]
        <>^\AC bes4.\pp r8 r4 |
        bes4. r8 r4 |
        es4. r8 r4 |
        es4. r8 r4 |
        bes4. r8 r4 |
        es4. r8 r4 |
        b,?2.\mf~ |
        b8 r r4 r |
        \barNumberCheck # 63
        % [6]
        <>^\markup\upright{spicc.} b'8.-.\mf[ cis16-. dis8-. cis-. b-. a-.] |
        b-. a-. gis-. fis-. e-. dis-. |
        cis-. b-. cis-. dis-. e-. fis-. |
        gis-. b4-> e8-. b-. gis-. |
        a8.-.[ b16-. d?8-. c?-. b-. a-.] |
        gis-. fis-. e-. dis-. e-. fis-. |
        gis-. e4 b e,8[~ |
        e] b'-. e-. gis-. b-. e-. |
        \barNumberCheck # 71
        % [7]
        b8.-.\f[ cis16-. dis8-. cis-. b-. a-.] |
        b-. a-. gis-. fis-. e-. dis-. |
        cis-. b-. cis-. dis-. e-. fis-. |
        gis-. b4-> e8-. b-. gis-. |
        a8.-.[ b16-. d?8-. c?-. b-. a-.] |
        b,2. |
        \at 4 \> b~ <>\! |
    % }
    \barNumberCheck # 78
    % \alternative {
        b2 r4 |
        % [8]
        <>\pp^\PZ \repeat unfold 3 {
            g4 r r |
            R2. |
        }
        g4 r r |
        g4 r r |
        <>-\offset X-offset #1.0 ^\AC g2.\pp |
        g |
    % } {
        b2\repeatTie r4 |
    % }
    \barNumberCheck # 90
    % [9]
    \at 2. ^\markup{Flag.} \at 2. \Ppp \repeat unfold 4 {
        R2. |
        gis''='4.\flageolet r8 r4 |
    }
    c,,=4\p a' r |
    b, g' r |
    a, \at 4 \> es'2\Hxso\< <>\! |
    R2. |
    a,4 a' r |
    gis, gis' r |
    g, g' r |
    R2. |
    \barNumberCheck # 106
    % [10]
    <>\pp \repeat unfold 7 { fis,2.-> | }
    gis'-> |
    fis-> |
    fis-> |
    e-> |
    \barNumberCheck # 117
    % [11]
    r4 <>^\PZ e\p d' |
    R2. |
    <>^\AC d,2.\p |
    R |
    <>-\offset X-offset #1.0 ^\PZ f4\pp r r |
    c r r |
    f r r |
    c r r |
    as' r r |
    c, r r |
    f -\tweak to-barline ##f \> r r |
    c\! r r |
    \barNumberCheck # 129
    % [12]
    \at 4 \pp \repeat unfold 2 {
        r4 <c, g'>2\arpeggio~ |
        q4 r r |
    }
    r r <>^\PZ g'\pp |
    g' r r |
    \barNumberCheck # 135
    % [13]
    r f,\pp c' |
    as' r r |
    R2.*2 |
    r4 q\ppp\arpeggio r |
    R2. |
    <>^\AC g'2.\ppp~ |
    g |
    R2. |
    <>^\PZ q4\ppp r r |
    q r r\fermata |
    \barNumberCheck # 146
}
>>


mvtIcb = <<
\mvtItimeline
\relative c {
    \transposition c
    % \time 4/4
    \clef bass
    <>^\Dmit
    R1*7 |
    \barNumberCheck # 8
    % \time 3/4
    <>^\PZ c4\p r r |
    b r r |
    a r r |
    R2. |
    a4 r r |
    gis r r |
    g! r r |
    R2. |
    \barNumberCheck # 16
    % [1]
    <>\pp \repeat unfold 7 { fis4 r r | }
    <>^\AC e''2.-> |
    dis-> |
    d!-> |
    c-> |
    \barNumberCheck # 27
    % [2]
    b-> |
    R |
    a\p |
    R |
    <>^\PZ f4\pp r r |
    c r r |
    f r r |
    c r r |
    as' r r |
    c, r r |
    f -\tweak to-barline ##f \> r r |
    c\! r r |
    \barNumberCheck # 39
    % \repeat volta 2 {
        % [3]
        R2.*4 |
        r4 <>^\PZ g\pp r |
        R2. |
        r4 c r |
        R2. |
        \barNumberCheck # 47
        % [4]
        <>-\offset X-offset #1.0 ^\AC g'\p |
        \repeat unfold 3 {
            R |
            g |
        }
        R |
        \barNumberCheck # 55
        % [5]
        R2.*6 |
        e2.\mf~ |
        e8 r r4 r |
        \barNumberCheck # 63
        % [6]
        <>\mf^\PZ \repeat unfold 8 { b4 r r | }
        \barNumberCheck # 71
        % [7]
        <>\f \repeat unfold 6 { b4 r r | }
        <>^\AC \at 4 \> e2.~ <>\! |
    % }
    \barNumberCheck # 78
    % \alternative {
        e2 r4 |
        % [8]
        R2.*8 |
        <>\pp-\offset X-offset #1.0 ^\PZ \repeat unfold 2 { g,4 r r | }
    % } {
        e'2\repeatTie r4 |
    % }
    \barNumberCheck # 90
    % [9]
    R2.*8 |
    <>^\PZ c4\p r r |
    b r r |
    a r r |
    R2. |
    a4 r r |
    gis r r |
    g! r r |
    R2. |
    \barNumberCheck # 106
    % [10]
    <>\pp \repeat unfold 7 { fis4 r r | }
    <>^\AC e''2.-> |
    dis-> |
    d!-> |
    c-> |
    \barNumberCheck # 117
    % [11]
    b-> |
    R |
    a\p |
    R |
    <>-\offset X-offset #1.0 ^\PZ f4\pp r r |
    c r r |
    f r r |
    c r r |
    as' r r |
    c, r r |
    f -\tweak to-barline ##f \> r r |
    c\! r r |
    \barNumberCheck # 129
    % [12]
    R2.*4 |
    r4 <>^\PZ g\pp r |
    R2. |
    \barNumberCheck # 135
    % [13]
    r4 f\pp r |
    R2.*8 |
    c'4\ppp r r |
    c r r\fermata |
    \barNumberCheck # 146
}
>>


\addQuote mvtIflI       { \mvtIflI }
\addQuote mvtIflII      { \removeWithTag KEEPQUOTED \mvtIflII }
\addQuote mvtIobI       { \mvtIobI }
\addQuote mvtIclrI      { \mvtIclrI }
\addQuote mvtIfgI       { \mvtIfgI }

\addQuote mvtIvlnI      { \mvtIvlnI }
\addQuote mvtIvlnII     { \mvtIvlnII }
\addQuote mvtIvla       { \mvtIvla }
